<copyright> DNEWS `Article in Group' class.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996 Pieter J. Schoenmakers.
    All rights reserved.

    <id>$Id: AinG.t,v 1.4 1996/11/25 17:26:23 tiggr Exp $</id>
    </copyright>

implementation class
AinG: State
{
  <doc> The attributes in which we're interested when fetching an article.
    </doc>
  static Array attributes;

  <doc> The uniqued strings of attribute names.  </doc>
  static String a_msg_id;
}

redefine void
  load Array arguments
{
  a_msg_id = ["msg_id" uniqueString];
  attributes = [ObjectArray with (a_msg_id)];
}

instance (id)
     createArticle Article a
	withNumber int n
	   inGroup Group g
	inDatabase Database db
{
  UniqueString msg_id = [a message_id];
  ObjectID gid = [g oid];

  [db exec [[MutableByteString withCapacity 512]
	     print ("insert into a_in_g (group_id, msg_id, number) values (",
		    gid, ", '", msg_id, "', ", n, ')')]];

  = [[self alloc] initWithGroupID gid messageID msg_id number n];
}

instance (id)
     article int number
     inGroup ObjectID gid
  inDatabase Database db
{
  [db exec [[MutableByteString withCapacity 512]
	     print ("select msg_id from a_in_g where group_id=", gid,
		    " and number=", number)]];

  int n = [db numRows];
  if (n == 1)
    {
      Mapped row = [db fetchAttributes attributes];

      = [[self alloc] initWithGroupID gid messageID row[a_msg_id]
		      number number];
    }
  else
    {
      if (n > 1)
	[[[Server errorStream]
	  print ("WARNING ", n, " articles with number ", number,
		 " in group with ID ", gid)] nl];
      = nil;
    }
}

end;

implementation instance
AinG
{
  <doc> The group.  </doc>
  public ObjectID group_id;

  <doc> The message-id of the article.  </doc>
  public UniqueString message_id;

  <doc> The number of the article in the group.  </doc>
  public int number;
}

<doc> Designated initializer.  </doc>
id
  initWithGroupID ObjectID gid
	messageID UniqueString msg_id
	   number int n
{
  (group_id, message_id, number) = (gid, msg_id, n);

  = self;
}

redefine OutputStream
  write OutputStream s
{
  = [s print ("#<", [isa name], " ", [self address], " ",
	      message_id, " ", group_id, " ", number, ">")];
}

end;
